import QtQuick 2.15
import QtQuick.Window 2.15

Window {
    width: 640
    height: 480
    visible: true

    ListModel {
        id: fakeModel

        ListElement {
            visible: false
            tick: 0
        }
    }

    Column {
        spacing: 2

        Repeater {
            model: fakeModel

            Text {
                required visible
                required property int tick
                required property var model
                text: "hello required, tick: " + tick + ", model.visible: " + model.visible
            }
        }

        Repeater {
            model: fakeModel

            Text {
                visible: model.visible
                text: "hello old style, tick: " + model.tick
            }
        }
    }

    Timer {
        property int tick: 0
        interval: 1000
        repeat: true
        running: true
        onTriggered: {
            ++tick;
            fakeModel.set(0, {visible: !!(tick % 2), tick: tick});
        }
    }
}
